package api

import (
	"cr-svc/db/model"
	"cr-svc/db/repo"
	"errors"

	"github.com/gin-gonic/gin"
)

func Version(r *GinRouter) {
	r.GET("/versions", GetVersion)
	r.GET("/version/latest", VersionLatest)
}

func GetVersion(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	page, size, query := UtilQueryPageSize(c)
	return repo.RepoPageSearch(apictx.CreateRepoCtx(), &repo.PageSearchOptions{
		CollectName: repo.CollectionVersions,
		Page:        page,
		Size:        size,
		Query:       query,
	})
}

func VersionLatest(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	version := &model.Versions{}
	ok, err := repo.RepoSeachDoc(apictx.CreateRepoCtx(), &repo.DocSearchOptions{
		CollectName: repo.CollectionVersions,
	}, version)
	if !ok || err != nil {
		return nil, errors.New("未找到数据")
	}
	return version, nil
}
